<template>
  <div>
    <el-row class="filter-container" :gutter="20">
      <el-col :span="20">
        <slot name="filters">
        </slot>
      </el-col>
      <el-col :span="4">
        <slot name="buttons">
          <el-button class="filter-item" @click="$emit('go','create')" type="success" icon="el-icon-circle-plus">
            Nuevo
          </el-button>
        </slot>
      </el-col>
    </el-row>
    <el-table key="_id" :data="rows" v-loading="loading"
              @selection-change="selectionChange"
              border fit highlight-current-row width="100" stripe>
      <slot name="columns">
        <el-table-column
          v-for="(colDef, idx) in columns"
          :key="idx"
          :label="colDef.label"
          :prop="colDef.prop"
          :formatter="colDef.formatter"
          :min-width="colDef.minWidth"
        >
        </el-table-column>
      </slot>
      <slot name="operations">
        <el-table-column
          v-if="canUpdate || canRemove"
          label="Operaciones" :width="230" fixed="right" center>
          <el-row slot-scope="scope">
            <el-col v-if="canUpdate" :span="8">
              <el-button type="primary" size="mini" @click="$emit('go', 'update', scope.row._id)">
                Editar
              </el-button>
            </el-col>
            <el-col v-if="canRemove" :span="8">
              <el-button type="danger" size="mini" @click="$emit('remove', scope.row)">
                Borrar
              </el-button>
            </el-col>
            <el-col v-if="canPrint" :span="8">
              <el-button type="info" size="mini" @click="$emit('go', 'print', scope.row._id, true)">
                Imprimir
              </el-button>
            </el-col>
          </el-row>
        </el-table-column>
      </slot>
    </el-table>
  </div>
</template>

<script>
  import CrudTableMixin from './crud-table.mixin'

  export default {
    name: 'crud-table',
    mixins: [CrudTableMixin],
    props: {
      resourceName: {type: Object, required: true},
      rows: {type: Array, required: true},
      columns: {type: Array, required: false},
      loading: {type: Boolean, required: true}
    },
    methods: {
      selectionChange(...args) {
        this.$emit('selection-change', ...args)
      }
    },
    data() {
      return {
        query: {
          name: {$search: ''}
        }
      }
    }
  }
</script>

<style lang="scss">
  .el-pagination {
    margin: 20px 0px;
    text-align: center;
  }
</style>
